/* BCP out all tables by Kevin Kline, http://blogs.sqlsentry.com, Twitter at @kekline */

SET NOCOUNT ON
CREATE TABLE #a (name VARCHAR(128), id INT IDENTITY)
INSERT #a (name)  SELECT name FROM sysobjects WHERE xtype = 'U'
DECLARE @id INT, @cmd VARCHAR(2000)
SELECT @id = 0
WHILE @id < (SELECT max(id) FROM #a)
BEGIN
	SELECT @id = MIN(id) FROM #a WHERE id > @id
	SELECT @cmd = 'bcp ' + db_name() + '..' + name + ' out "c:\temp\' + name + '.bcp" -S' + @@servername + ' -N -T -F1 -L5000'
		FROM #a WHERE id = @id
		-- The bcp command line switches create a tab delimited file, starting at record #1 (-F1) and ending at record #500 (-L500)
		--    Change those as needed, in case you need more or less records than the first 500 in the table.
	EXEC master..xp_cmdshell @cmd
		-- The output is all of the bcp commands. If xp_cmdshell is disabled, simply take the output and run it manually in your
		--    own command-line, assuming your account has appropriate permissions.
	SELECT @cmd
END
DROP TABLE #a

-- Q. Notice any problems with this code?
--   A. It's just quick and dirty code. It has no handling for database name, schema name, db owner, etc.